<?php

$no_http_headers = true;
include(dirname(__FILE__) . "/../include/global.php");
include(dirname(__FILE__) . "/../lib/snmp.php");

$oids = array("index" => ".1.3.6.1.2.1.10.20.1.3.2.1.2",
			"chcount" => ".1.3.6.1.2.1.10.20.1.3.2.1.6",
			"status" => ".1.3.6.1.2.1.10.20.1.3.2.1.8",
			"calls_in" => ".1.3.6.1.2.1.10.20.1.3.3.1.1",
			"calls_in_conn" => ".1.3.6.1.2.1.10.20.1.3.3.1.2",
			"calls_out" => ".1.3.6.1.2.1.10.20.1.3.3.1.3",
			"calls_out_conn" => ".1.3.6.1.2.1.10.20.1.3.3.1.4"
			);

$ifoids = array("ifDescr" => ".1.3.6.1.2.1.2.2.1.2",
					"ifType" => ".1.3.6.1.2.1.2.2.1.3",
					"ifAdminStatus" => ".1.3.6.1.2.1.2.2.1.7",
					"ifOperStatus" => ".1.3.6.1.2.1.2.2.1.8",
					"ifName" => ".1.3.6.1.2.1.31.1.1.1.1",
					"ifAlias" => ".1.3.6.1.2.1.31.1.1.1.18");
		
	
//foreach($oids as $key => $value) {print "$key => $value\n";}

$hostname = $_SERVER["argv"][1];
$snmp_community = $_SERVER["argv"][2];
$snmp_version = $_SERVER["argv"][3];
$cmd = $_SERVER["argv"][4];

// Index mode - return list of indexes
if ($cmd == "index")
	{
	//print "INDEX Requested\n";
	$arr_index = get_indexes($hostname, $snmp_community, $snmp_version);
	
	for ($i=0;($i<sizeof($arr_index));$i++) {
		print $arr_index[$i] . "\n";
		}
	}

// Query Mode return list of Index vs Field(argv:5)
elseif ($cmd == "query")
	{
	$arg = $_SERVER["argv"][5];
	
	$arr_index = get_indexes($hostname, $snmp_community, $snmp_version);
	switch ($arg)
		{
		case 'index':
			for ($i=0;($i<sizeof($arr_index));$i++)
				{
				print $arr_index[$i] . "!" . $arr_index[$i] . "\n";
				}
			break;
		case 'calls_in':
		case 'calls_in_conn':
		case 'calls_out':
		case 'calls_out_conn':
		case 'chcount':
		case 'status':		
			$arr = get_info($hostname, $snmp_community, $snmp_version, $arg);
			for ($i=0;($i<sizeof($arr_index));$i++)
				{
				print $arr_index[$i] . "!" . $arr[$i] . "\n";
				}
			break;
		case 'ifName':
		case 'ifDescr':
		case 'ifType':
		case 'ifAlias':
		case 'ifAdminStatus':
		case 'ifOperStatus':
			$arr = get_ifinfo($hostname, $snmp_community, $snmp_version, $arg);
			for ($i=0;($i<sizeof($arr_index));$i++)
				{
				print $arr_index[$i] . "!" . $arr[$i] . "\n";
				}
			break;
			
		}
	}

// Get Mode - return Individual Value for Field (argv:5) and Index (argv:6)
elseif ($cmd == "get")
	{
	$arg = $_SERVER["argv"][5];
	$index = $_SERVER["argv"][6];
	
	
	switch ($arg)
		{
		case 'index':
			$arr_index = get_indexes($hostname, $snmp_community, $snmp_version);
			print $arr_index[$index];
			break;
		case 'calls_in':
		case 'calls_in_conn':
		case 'calls_out':
		case 'calls_out_conn':
		case 'chcount':
		case 'status':		
			$arr_index = get_indexes($hostname, $snmp_community, $snmp_version);
			$t_oid = $oids[$arg].".".($index+1);
			print cacti_snmp_get($hostname, $snmp_community, $t_oid, $snmp_version, "", "", "", "", "", "", "", 161, 1000);
			break;
		case 'ifName':
		case 'ifDescr':
		case 'ifType':
		case 'ifAlias':
		case 'ifAdminStatus':
		case 'ifOperStatus':
			$arr_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, "", "", "", "", "", "", "", 161, 1000));
			$t_oid = $ifoids[$arg].".".$arr_index[$index];
			print cacti_snmp_get($hostname, $snmp_community, $t_oid, $snmp_version, "", "", 161, 1000);
			break;
			
		}
	}


// Get Specific Info for ISDN Index from ifIndex
function get_ifinfo($hostname, $snmp_community, $snmp_version, $arg) {
	global $oids,$ifoids;
					
	$arr_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, "", "", "", "", "", "", "", 161, 1000));
	$return_arr = array();
	
	for ($i=0;($i<sizeof($arr_index));$i++)
		{
		$t_oid =  $ifoids[$arg].".".$arr_index[$i];
		//print "$t_oid\n";
		$return_arr[$i] = cacti_snmp_get($hostname, $snmp_community, $t_oid, $snmp_version, "", "", "", "", "", "", "", 161, 1000);
		}
	
	return $return_arr;
}



function get_info($hostname, $snmp_community, $snmp_version,$arg) {
	global $oids;
	//print ("get_info for $arg\n");
	$arr = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, "", "", "", "", "", "", "", 161, 1000));
	//reach($arr as $key => $value) {print "$key => $value\n";}
	$return_arr = array();
	
	$j = 0;
	
	for ($i=0;($i<sizeof($arr));$i++) {
		if (ereg("^[0-9]+$", $arr[$i])) {
			$return_arr[$j] = $arr[$i];
			$j++;
		}
	}
	
	return $return_arr;
}

function get_indexes($hostname, $snmp_community, $snmp_version) {
	global $oids;
//	print ("get_indexes\n");
  $arr = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, "", "", "", "", "", "", "", 161, 1000));
//	print "Array: arr\n"; foreach($arr as $key => $value) {print "$key => $value\n";}
	$return_arr = array();
	
	$j = 0;
	
	for ($i=0;($i<sizeof($arr));$i++) {
		if (ereg("^[0-9]+$", $arr[$i])) {
			$return_arr[$j] = $j;
			$j++;
		}
	}
	
	return $return_arr;
}

function reindex($arr) {
	$return_arr = array();
//	print ("reindex\n");	
	for ($i=0;($i<sizeof($arr));$i++) {
		$return_arr[$i] = $arr[$i]["value"];
	}
	
	return  $return_arr;
}

?>
